//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3E034D1A0233.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3E034D1A0233.cm

//## begin module%3E034D1A0233.cp preserve=no
//## end module%3E034D1A0233.cp

//## Module: PlotModel%3E034D1A0233; Package specification
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotModel.h

#ifndef PLOTMODEL_H
#define PLOTMODEL_H 1

//## begin module%3E034D1A0233.additionalIncludes preserve=no
//## end module%3E034D1A0233.additionalIncludes

//## begin module%3E034D1A0233.includes preserve=yes
//## end module%3E034D1A0233.includes

// PlotCommand
#include <XSPlot/Plot/PlotCommand.h>
//## begin module%3E034D1A0233.declarations preserve=no
//## end module%3E034D1A0233.declarations

//## begin module%3E034D1A0233.additionalDeclarations preserve=yes
class PlotGroup;
class PlotSettings;
struct StandardLabels;
//## end module%3E034D1A0233.additionalDeclarations


//## begin PlotModel%3E034BF401CF.preface preserve=yes
//## end PlotModel%3E034BF401CF.preface

//## Class: PlotModel%3E034BF401CF
//## Category: XSPlot::PlotCommands%3DAF12C70234
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PlotModel : public PlotCommand  //## Inherits: <unnamed>%4B3A73B302D6
{
  //## begin PlotModel%3E034BF401CF.initialDeclarations preserve=yes
  //## end PlotModel%3E034BF401CF.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: PlotModel%4B3A743F0048
      PlotModel (const string& name);

    //## Destructor (generated)
      virtual ~PlotModel();


    //## Other Operations (specified)
      //## Operation: makeLabels%4B3A765302CE
      //	If not overridden, this does nothing.
      virtual void makeLabels (const PlotSettings& settings, StandardLabels& labels) const;

      //## Operation: requestNewXoption%4B3A76590030
      virtual bool requestNewXoption (const PlotSettings& settings, XaxisMode& newOption) const;

      //## Operation: processAdditionalParams%4B3A7A630173
      virtual void processAdditionalParams (const StringArray& args, const IntegerArray& argIndices);

    // Additional Public Declarations
      //## begin PlotModel%3E034BF401CF.public preserve=yes
      //## end PlotModel%3E034BF401CF.public

  protected:
    // Additional Protected Declarations
      //## begin PlotModel%3E034BF401CF.protected preserve=yes
      //## end PlotModel%3E034BF401CF.protected

  private:
    //## Constructors (generated)
      PlotModel(const PlotModel &right);

    //## Assignment Operation (generated)
      PlotModel & operator=(const PlotModel &right);


    //## Other Operations (specified)
      //## Operation: manipulate%4B3A76390276
      //	Once the raw data has been gathered into PlotGroup
      //	objects, this is the function that performs the various
      //	mathematical operations specific to each PlotCommand
      //	subclass.
      virtual void manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings);

      //## Operation: setRanges%4B3A764000F8
      //	Determines plot-time range settings based on current
      //	setplot settings and PlotGroup data.
      virtual void setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings);

    // Additional Private Declarations
      //## begin PlotModel%3E034BF401CF.private preserve=yes
      //## end PlotModel%3E034BF401CF.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin PlotModel%3E034BF401CF.implementation preserve=yes
      //## end PlotModel%3E034BF401CF.implementation

};

//## begin PlotModel%3E034BF401CF.postscript preserve=yes
//## end PlotModel%3E034BF401CF.postscript

// Class PlotModel 

//## begin module%3E034D1A0233.epilog preserve=yes
//## end module%3E034D1A0233.epilog


#endif
